<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CategoryProductAttributeList StructType
 * @subpackage Structs
 */
class CategoryProductAttributeList extends AbstractStructBase
{
    /**
     * The categoryProductAttribute
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CategoryProductAttributeData[]
     */
    public $categoryProductAttribute;
    /**
     * Constructor method for CategoryProductAttributeList
     * @uses CategoryProductAttributeList::setCategoryProductAttribute()
     * @param \StructType\CategoryProductAttributeData[] $categoryProductAttribute
     */
    public function __construct(array $categoryProductAttribute = array())
    {
        $this
            ->setCategoryProductAttribute($categoryProductAttribute);
    }
    /**
     * Get categoryProductAttribute value
     * @return \StructType\CategoryProductAttributeData[]|null
     */
    public function getCategoryProductAttribute()
    {
        return $this->categoryProductAttribute;
    }
    /**
     * This method is responsible for validating the values passed to the setCategoryProductAttribute method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCategoryProductAttribute method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCategoryProductAttributeForArrayConstraintsFromSetCategoryProductAttribute(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $categoryProductAttributeListCategoryProductAttributeItem) {
            // validation for constraint: itemType
            if (!$categoryProductAttributeListCategoryProductAttributeItem instanceof \StructType\CategoryProductAttributeData) {
                $invalidValues[] = is_object($categoryProductAttributeListCategoryProductAttributeItem) ? get_class($categoryProductAttributeListCategoryProductAttributeItem) : sprintf('%s(%s)', gettype($categoryProductAttributeListCategoryProductAttributeItem), var_export($categoryProductAttributeListCategoryProductAttributeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The categoryProductAttribute property can only contain items of type \StructType\CategoryProductAttributeData, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set categoryProductAttribute value
     * @throws \InvalidArgumentException
     * @param \StructType\CategoryProductAttributeData[] $categoryProductAttribute
     * @return \StructType\CategoryProductAttributeList
     */
    public function setCategoryProductAttribute(array $categoryProductAttribute = array())
    {
        // validation for constraint: array
        if ('' !== ($categoryProductAttributeArrayErrorMessage = self::validateCategoryProductAttributeForArrayConstraintsFromSetCategoryProductAttribute($categoryProductAttribute))) {
            throw new \InvalidArgumentException($categoryProductAttributeArrayErrorMessage, __LINE__);
        }
        $this->categoryProductAttribute = $categoryProductAttribute;
        return $this;
    }
    /**
     * Add item to categoryProductAttribute value
     * @throws \InvalidArgumentException
     * @param \StructType\CategoryProductAttributeData $item
     * @return \StructType\CategoryProductAttributeList
     */
    public function addToCategoryProductAttribute(\StructType\CategoryProductAttributeData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CategoryProductAttributeData) {
            throw new \InvalidArgumentException(sprintf('The categoryProductAttribute property can only contain items of type \StructType\CategoryProductAttributeData, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->categoryProductAttribute[] = $item;
        return $this;
    }
}
