<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CategoryProductAttributeValueList StructType
 * @subpackage Structs
 */
class CategoryProductAttributeValueList extends AbstractStructBase
{
    /**
     * The categoryProductAttributeValue
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CategoryProductAttributeValueData[]
     */
    public $categoryProductAttributeValue;
    /**
     * Constructor method for CategoryProductAttributeValueList
     * @uses CategoryProductAttributeValueList::setCategoryProductAttributeValue()
     * @param \StructType\CategoryProductAttributeValueData[] $categoryProductAttributeValue
     */
    public function __construct(array $categoryProductAttributeValue = array())
    {
        $this
            ->setCategoryProductAttributeValue($categoryProductAttributeValue);
    }
    /**
     * Get categoryProductAttributeValue value
     * @return \StructType\CategoryProductAttributeValueData[]|null
     */
    public function getCategoryProductAttributeValue()
    {
        return $this->categoryProductAttributeValue;
    }
    /**
     * This method is responsible for validating the values passed to the setCategoryProductAttributeValue method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCategoryProductAttributeValue method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCategoryProductAttributeValueForArrayConstraintsFromSetCategoryProductAttributeValue(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $categoryProductAttributeValueListCategoryProductAttributeValueItem) {
            // validation for constraint: itemType
            if (!$categoryProductAttributeValueListCategoryProductAttributeValueItem instanceof \StructType\CategoryProductAttributeValueData) {
                $invalidValues[] = is_object($categoryProductAttributeValueListCategoryProductAttributeValueItem) ? get_class($categoryProductAttributeValueListCategoryProductAttributeValueItem) : sprintf('%s(%s)', gettype($categoryProductAttributeValueListCategoryProductAttributeValueItem), var_export($categoryProductAttributeValueListCategoryProductAttributeValueItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The categoryProductAttributeValue property can only contain items of type \StructType\CategoryProductAttributeValueData, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set categoryProductAttributeValue value
     * @throws \InvalidArgumentException
     * @param \StructType\CategoryProductAttributeValueData[] $categoryProductAttributeValue
     * @return \StructType\CategoryProductAttributeValueList
     */
    public function setCategoryProductAttributeValue(array $categoryProductAttributeValue = array())
    {
        // validation for constraint: array
        if ('' !== ($categoryProductAttributeValueArrayErrorMessage = self::validateCategoryProductAttributeValueForArrayConstraintsFromSetCategoryProductAttributeValue($categoryProductAttributeValue))) {
            throw new \InvalidArgumentException($categoryProductAttributeValueArrayErrorMessage, __LINE__);
        }
        $this->categoryProductAttributeValue = $categoryProductAttributeValue;
        return $this;
    }
    /**
     * Add item to categoryProductAttributeValue value
     * @throws \InvalidArgumentException
     * @param \StructType\CategoryProductAttributeValueData $item
     * @return \StructType\CategoryProductAttributeValueList
     */
    public function addToCategoryProductAttributeValue(\StructType\CategoryProductAttributeValueData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CategoryProductAttributeValueData) {
            throw new \InvalidArgumentException(sprintf('The categoryProductAttributeValue property can only contain items of type \StructType\CategoryProductAttributeValueData, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->categoryProductAttributeValue[] = $item;
        return $this;
    }
}
